package br.usp.pmr.laboratorio;


import javax.swing.JFrame;
import javax.swing.*;


import java.awt.event.*;
import java.awt.*;

/*
 * Created on 15/03/2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author fktakase
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */



public class FrameGrafico extends JFrame implements ActionListener{
	public static final int LARGURA=640;
	public static final int ALTURA=480;
	
	//caixa de dialogo para entrada de parametros da reta
	private JDialog caixaDeDialogoReta;
	private JButton botaoOKDialogoReta;
	private JButton botaoCancelaDialogoReta;
	private JTextField parametroRetaA;
	private JTextField parametroRetaB;

	//caixa de dialogo para entrada de parametros da parabola
	private JDialog caixaDeDialogoParabola;
	private JButton botaoOKDialogoParabola;
	private JButton botaoCancelaDialogoParabola;
	private JTextField parametroParabolaA;
	private JTextField parametroParabolaB;
	private JTextField parametroParabolaC;

	
	private PainelDePlotagem pp;
	
	
	//construtor sem parametros da classe FrameGrafico
	public FrameGrafico(){
		//chama o construtor da classe pai, no caso, a classe JFrame
		super();
		//inicializa o frame
		init();
		//estabelece um nome padrao para a janela
		setTitle("Nome Padrao");
		//estabelece uma cor padrao para o fundo da janela
		getContentPane().setBackground(Color.blue);
	}
	
	//construtor "sobrecarregado" com parametros (titulo da janela e cor de fundo da janela)
	//da classe FrameGrafico
	public FrameGrafico(String tituloAplicacao, Color corAplicacao){
		//chama o construtor da classe pai, no caso a classe JFrame
		super();
		//inicializa a classe FrameGrafico
		init();
		//determina o titulo da janela (informado pelo usuario)
		setTitle(tituloAplicacao);
		//determina a cor de fundo da janela (informada pelo usuario)
		getContentPane().setBackground(corAplicacao);
	}

	//Metodo que inicializa o FrameGrafico, posicionando os seus componentes
	private void init(){
		//determina o tamanho da janela
		setSize(LARGURA,ALTURA);
		
		//cria painel onde serao posicionados os botoes
		JPanel painelDeBotoes = new JPanel();
		//determina a cor de fundo do painel de botoes
		painelDeBotoes.setBackground(Color.lightGray);
		//escolhe o leioute para o painel de botoes
		painelDeBotoes.setLayout( new FlowLayout());
		
		//cria o botao para retas
		JButton botaoReta = new JButton("Nova Reta");
		//determina a cor de fundo do botao de retas
		botaoReta.setBackground(Color.lightGray);
		//adiciona o listener para o botao - necessario para tratar evento de clique do mouse
		botaoReta.addActionListener(this);
		//adiciona o botao de retas no painel de botoes
		painelDeBotoes.add(botaoReta);
		
		//cria botao para parabolas
		JButton botaoParabola = new JButton("Nova Parabola");
		//estabelece a cor de fundo do botao
		botaoParabola.setBackground(Color.lightGray);
		//adiciona o listener para o botao - necessario para tratar evento de clique do mouse
		botaoParabola.addActionListener(this);
		//adiciona o botao de parabolas ao painel de botoes
		painelDeBotoes.add(botaoParabola);
		
		//adiciona o painel de botoes na porcao SUL do frame grafico
		getContentPane().add(painelDeBotoes,BorderLayout.SOUTH);
		
		//cria uma instancia do painel de plotagem
		pp = new PainelDePlotagem();
		//adiciona o painel de plotagem no centro do frame grafico
		getContentPane().add(pp,BorderLayout.CENTER);	
		
	    //trata o evento de fechamento da janela
		addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent e){System.exit(0);}});
	}
	
	//tratamento dos eventos - botoes
	public void actionPerformed(ActionEvent e)
	{
		Container contentPane = getContentPane();
		
		//eventos relacionados a Reta
		if(e.getActionCommand().equals("Nova Reta")){
			NovaReta();
		} else if (e.getSource().equals(botaoOKDialogoReta)) {
			pp.adicionaFuncao(new Reta(Integer.parseInt(parametroRetaA.getText()),Integer.parseInt(parametroRetaB.getText())),Color.BLUE );
			caixaDeDialogoReta.dispose();
			caixaDeDialogoReta = null;
		} else if (e.getSource().equals(botaoCancelaDialogoReta)) {
			caixaDeDialogoReta.dispose();
			caixaDeDialogoReta = null;
		
		//eventos relacionados a Parabola
		} else if (e.getActionCommand().equals("Nova Parabola")){
			NovaParabola();
		} else if (e.getSource().equals(botaoOKDialogoParabola)) {
			pp.adicionaFuncao(new Parabola(Integer.parseInt(parametroParabolaA.getText()),Integer.parseInt(parametroParabolaB.getText()),Integer.parseInt(parametroParabolaC.getText())),Color.BLUE );
			caixaDeDialogoParabola.dispose();
			caixaDeDialogoParabola = null;
		} else if (e.getSource().equals(botaoCancelaDialogoParabola)) {
			caixaDeDialogoParabola.dispose();
			caixaDeDialogoParabola = null;
		} else {
			System.out.println("OHOH");
		}
		
	}
	public void NovaReta(){
		caixaDeDialogoReta = new JDialog();
		caixaDeDialogoReta.setSize(200,100);
		caixaDeDialogoReta.setTitle("Parametros da Linha");
		caixaDeDialogoReta.setLayout(new BorderLayout());
		
	    JPanel painelDeBotaoReta = new JPanel();
	    botaoOKDialogoReta = new JButton("OK");
	    botaoOKDialogoReta.addActionListener(this);
	    painelDeBotaoReta.add(botaoOKDialogoReta);
	    
	    botaoCancelaDialogoReta = new JButton("Cancela");
	    botaoCancelaDialogoReta.addActionListener(this);
	    painelDeBotaoReta.add(botaoCancelaDialogoReta);
	    caixaDeDialogoReta.add(painelDeBotaoReta,BorderLayout.SOUTH);
	
	    parametroRetaA = new JTextField(1);
	    parametroRetaB = new JTextField(1);
	    
	    JPanel painelParametrosReta = new JPanel();
	    painelParametrosReta.setLayout(new FlowLayout());
	    painelParametrosReta.add(new JLabel("f(x)= "));
	    painelParametrosReta.add(parametroRetaA);
	    painelParametrosReta.add(new JLabel("*x + "));
	    painelParametrosReta.add(parametroRetaB);
	    caixaDeDialogoReta.add(painelParametrosReta,BorderLayout.CENTER);
	   
	    caixaDeDialogoReta.setVisible(true);
	}
	
	public void NovaParabola(){
		caixaDeDialogoParabola = new JDialog();
		caixaDeDialogoParabola.setSize(200,100);
		caixaDeDialogoParabola.setTitle("Parametros da Parabola");
		caixaDeDialogoParabola.setLayout(new BorderLayout());
		
	    JPanel painelDeBotaoParabola = new JPanel();
	    botaoOKDialogoParabola = new JButton("OK");
	    botaoOKDialogoParabola.addActionListener(this);
	    painelDeBotaoParabola.add(botaoOKDialogoParabola);
	    
	    botaoCancelaDialogoParabola = new JButton("Cancela");
	    botaoCancelaDialogoParabola.addActionListener(this);
	    painelDeBotaoParabola.add(botaoCancelaDialogoParabola);
	    caixaDeDialogoParabola.add(painelDeBotaoParabola,BorderLayout.SOUTH);
	
	    parametroParabolaA = new JTextField(1);
	    parametroParabolaB = new JTextField(1);
	    parametroParabolaC = new JTextField(1);
	    
	    JPanel painelParametrosParabola = new JPanel();
	    painelParametrosParabola.setLayout(new FlowLayout());
	    painelParametrosParabola.add(new JLabel("f(x)= "));
	    painelParametrosParabola.add(parametroParabolaA);
	    painelParametrosParabola.add(new JLabel("*x^2 + "));
	    painelParametrosParabola.add(parametroParabolaB);
	    painelParametrosParabola.add(new JLabel("*x + "));
	    painelParametrosParabola.add(parametroParabolaC);
	    caixaDeDialogoParabola.add(painelParametrosParabola,BorderLayout.CENTER);
	  
	    caixaDeDialogoParabola.setVisible(true);
	}

}
