/* 
 * SimpleWebServer.java
 * Autor: Marcos Barretto.
 */

import java.net.ServerSocket;
import java.net.Socket;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.String;
import java.util.Date;
import java.util.StringTokenizer;
import java.io.FileInputStream;

public class SimpleWebServer {
    
    static final int SERVER_SOCKET = 2001;
    
    public static void main(String[] args) {
        try {
          ServerSocket ss = new ServerSocket(SERVER_SOCKET);
          while (true) {
            Socket s = ss.accept();
            HttpResponder hr = new HttpResponder(s);
            hr.processRequests();
          } // while    
        } catch(Exception e) {e.printStackTrace(); }
    }    
    

} // SimpleServer    

class HttpResponder {
    Socket m_Socket = null;
    static String BASE_DIR="d:/fgcozman/Didatico/Aulas/Graduacao/PMR2300/2003/Labs/Sockets/";
      
    HttpResponder(Socket s) {
            m_Socket = s;
    } //HttpResponder
        
    void processRequests() {
      try {
        String request = getRequest();
        System.out.println(request);
        String file = getFileName(request);
        System.out.println(file);
        sendFile(file);
      } catch (Exception e) { e.printStackTrace(); }    
    } // processRequests   
   
    String getFileName(String request) {
        StringTokenizer st = new StringTokenizer(request);
        st.nextToken();
        return st.nextToken();
    } // getFileName
    
    void sendFile(String filename) throws Exception{
        OutputStream os = m_Socket.getOutputStream();
        FileInputStream fis = new FileInputStream(BASE_DIR + filename);
        byte[] bytes = new byte[2048];
        fis.read(bytes);
        os.write(bytes);
        os.close();
    } // sendFile
    
    String getRequest() throws Exception {
        BufferedInputStream bis = new BufferedInputStream(m_Socket.getInputStream());
        int ch;
        String request = "";
        byte[] buf = new byte[1];
        while ( (ch = bis.read()) != -1) {
            //System.out.println("" + ch);
            if (ch == 13) {
                return request;
            } else {
                buf[0] = (byte)ch;
                request += new String(buf);
            }
        } // while    
        return null;
    } // getRequest
 } // HttpResponder    
